package org.rcisoft.business.buildtp.controller;


/*固定导入*/

import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.controller.PaginationController;
import org.rcisoft.core.model.GridModel;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.rcisoft.core.util.UserUtil;
import org.rcisoft.business.buildtp.entity.BuildTp;
import org.rcisoft.business.buildtp.service.BuildTpService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

/**
*
 * @author
 * @date 2018-4-3 10:11:34
 */
@RestController//
/*@RestController=@Controller+@ResponseBody
*
*  返回json数据不需要在方法前面加@ResponseBody注解了，但是使用@RestController这个注解，就不能返回jsp,html页面，视图解析器无法解析jsp，html页面
*
* */
@RequestMapping("buildtp")
public class BuildTpController extends PaginationController<BuildTp> {
    
    @Autowired
    private BuildTpService buildTpServiceImpl;

    /*
     * @ApiOperation注解不是Spring自带的，他是swagger里的，它是swagger里的
     * 注解@ApiOperation是用来构建API文档的
     * @ApiOperation(value="接口说明",httpMethod="接口请求方式"，response="接口返回参数类型"，notes="接口发布说明")
     */
    @ApiOperation(value="添加建筑类型", notes="添加建筑类型")
    @PostMapping(value = "/add")//
/*    // @PostMapping 是一个组合注解 是@RequestMapping(method=RequestMethod.POST)的缩写*/
    public Result add(@Valid BuildTp buildTp) {
        PersistModel data = buildTpServiceImpl.save(buildTp);
        return Result.builder(data);
    }

    @ApiOperation(value="修改建筑类型", notes="修改建筑类型")
    @PutMapping("/update")
    public Result update(@Valid BuildTp buildTp) {
        PersistModel data = buildTpServiceImpl.merge(buildTp);
        return Result.builder(data);
    }

    @ApiOperation(value="删除建筑类型", notes="删除建筑类型")
    @DeleteMapping("/delete")
    public Result delete(@Valid BuildTp buildTp) {
        PersistModel data = buildTpServiceImpl.delete(buildTp);
        return Result.builder(data);
    }

    @ApiOperation(value="建筑类型列表", notes="建筑类型列表")
    @GetMapping(value = "/queryBuildTpList")
    public List<BuildTp> queryBuildTpList() {
        return buildTpServiceImpl.queryBuildTpList();
    }
}
