package org.rcisoft.business.device.report.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.device.report.service.ReportService;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * Created by JiChao on 2018/5/3.
 * 设备维护--设备报表
 */
@Api(tags = "设备报表")
@RestController
@RequestMapping("report")
public class ReportController {

    @Autowired
    private ReportService reportServiceImpl;

    @ApiOperation(value="下载文件", notes="下载文件")
    @ApiImplicitParams({@ApiImplicitParam(name = "proId", value = "项目主键", required = true, dataType = "字符串"),
            @ApiImplicitParam(name = "year", value = "年", required = true, dataType = "数字"),
            @ApiImplicitParam(name = "month", value = "月", required = true, dataType = "数字"),
            @ApiImplicitParam(name = "day", value = "日", required = true, dataType = "数字")})
    @RequestMapping("/download")
    public void download(HttpServletResponse response, @RequestParam String proId, Integer year, Integer month, Integer day) {
        reportServiceImpl.download(response, proId, year, month, day);
    }

    @ApiOperation(value="根据时间下载气温excel", notes="根据时间下载气温excel")
    @RequestMapping("/downloadTemperature")
    public void downloadTemperature(HttpServletResponse response, @RequestParam String proId, @RequestParam String start, @RequestParam String end) {
        reportServiceImpl.downloadTemperature(response, proId, start, end);
    }

//    @ApiOperation(value="得到存在的文件名称", notes="得到存在的文件名称")
//    @RequestMapping("/getExistFiles")
//    public Result getExistFiles(@RequestParam String proId, @RequestParam Integer year, @RequestParam Integer month) {
//        return Result.builder(new PersistModel(1),
//                MessageConstant.MESSAGE_ALERT_SUCCESS,
//                MessageConstant.MESSAGE_ALERT_ERROR,
//                reportServiceImpl.getExistFiles(proId, year, month));
//    }
}
