package org.rcisoft.business.device.report.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.device.report.entity.Formula;
import org.springframework.stereotype.Repository;
import tk.mybatis.mapper.common.Mapper;

import java.util.List;

/**
 * Created by JiChao on 2018/8/29.
 */
@Repository
public interface FormulaRepository extends Mapper<Formula> {

    @Insert("<script>insert into bus_formula(ID, NAME, FORMULA, PRO_ID, CREATE_TIME) " +
            "values(#{id}, #{name}, #{formula}, #{proId}, #{createTime})</script>")
    @ResultType(Integer.class)
    Integer addFormula(Formula formula);

    @Update("<script>update bus_formula set NAME=#{name},FORMULA=#{formula} where ID=#{id}</script>")
    @ResultType(Integer.class)
    Integer updateFormula(Formula formula);

    @Delete("<script>delete from bus_formula where ID=#{id}</script>")
    @ResultType(Integer.class)
    Integer deleteFormula(@Param("id") String id);

    @Select("<script>select * from bus_formula where id = #{id}</script>")
    @ResultMap("formula")
    Formula selectFormula(@Param("id") String id);

    @Select("<script>select * from bus_formula where PRO_ID=#{proId} order by CREATE_TIME desc</script>")
    @ResultMap("formula")
    List<Formula> selectFormulaList(@Param("proId") String proId);

    @Select("<script>select * from bus_formula where ID in " +
            "<foreach collection=\"array\" item=\"item\" open=\"(\" separator=\",\" close=\")\">" +
            "#{item}</foreach> " +
            "order by CREATE_TIME desc</script>")
    @ResultMap("formula")
    List<Formula> selectFormulas(String[] ids);

}
