package org.rcisoft.business.device.report.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.device.report.entity.Variable;
import org.springframework.stereotype.Repository;
import tk.mybatis.mapper.common.Mapper;

import java.util.List;

/**
 * Created by JiChao on 2018/8/29.
 */
@Repository
public interface VariableRepository extends Mapper<Variable> {

    /**
     * 批量新增
     * @param list
     * @return
     */
    @Insert("<script><foreach collection=\"list\" item=\"item\" separator=\";\">" +
            "insert into bus_variable(ID, VARIABLE, SOURCE, PARAM, FORMULA_ID, PRO_ID, CREATE_TIME, POSITION) " +
            "values(#{item.id}, #{item.variable}, #{item.source}, #{item.param}, #{item.formulaId}, #{item.proId}, #{item.createTime}, #{item.position})" +
            "</foreach></script>")
    @ResultType(Integer.class)
    Integer addVariable(List<Variable> list);

    /**
     * 根据公式id删除变量
     * @param formulaId
     * @return
     */
    @Delete("<script>delete from bus_variable where FORMULA_ID = #{formulaId}</script>")
    Integer deleteVariable(@Param("formulaId") String formulaId);

    /**
     * 根据公式id查找所有变量
     * @param formulaId
     * @return
     */
    @Select("<script>select * from bus_variable where FORMULA_ID = #{formulaId} order by POSITION asc</script>")
    @ResultMap("variable")
    List<Variable> selectVariable(@Param("formulaId") String formulaId);

    @Select("<script>select * from bus_variable where FORMULA_ID in " +
            "<foreach collection=\"array\" item=\"item\" open=\"(\" separator=\",\" close=\")\">" +
            "#{item}</foreach> " +
            " order by CREATE_TIME desc, POSITION asc</script>")
    @ResultMap("variable")
    List<Variable> selectVariables(String[] ids);

}
