package org.rcisoft.business.device.report.service;

import org.rcisoft.business.device.report.entity.Formula;
import org.rcisoft.business.device.report.vo.FormulaVo;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * Created by JiChao on 2018/8/31.
 */
public interface FormulaService {

    /**
     * 新增公式
     * @param formula
     * @return
     */
    Integer addFormula(Formula formula);

    /**
     * 编辑公式
     * @param formula
     * @return
     */
    Integer updateFormula(Formula formula);

    /**
     * 删除公式
     * @param id
     * @return
     */
    Integer deleteFormula(String id);

    /**
     * 根据id查询
     * @param id
     * @return
     */
    Formula selectFormula(String id);

    /**
     * 根据项目id查询公式的list
     * @param proId
     * @return
     */
    List<Formula> selectFormulaList(String proId);

    /**
     * 新增公式和变量
     * @param formulaVo
     * @return
     */
    Integer addFormulaVariable(FormulaVo formulaVo);

    /**
     * 编辑公式和变量
     * @param formulaVo
     * @return
     */
    Integer updateFormulaVariable(FormulaVo formulaVo);

    /**
     * 删除公式和变量
     * @param formulaId
     * @return
     */
    Integer deleteFormulaVariable(String formulaId);

    /**
     * 根据公式id查询公式和其所拥有的变量
     * @param formulaId
     * @return
     */
    FormulaVo selectFormulaVariable(String formulaId);

    /**
     * 导出公式excel数据
     * @param formulaId 公式id
     * @param start 开始时间
     * @param end 结束时间
     */
    void downloadFormula(HttpServletResponse response, String formulaId, String start, String end);

    /**
     * 批量导出公式
     * @param response
     * @param formulaIds 公式ids，逗号分隔
     * @param start
     * @param end
     */
    void downloadFormulas(HttpServletResponse response, String proId, String formulaIds, String start, String end);
}
