package org.rcisoft.business.device.report.service.impl;

import org.rcisoft.business.device.report.dao.VariableRepository;
import org.rcisoft.business.device.report.entity.Variable;
import org.rcisoft.business.device.report.service.VariableService;
import org.rcisoft.core.util.UuidUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * Created by JiChao on 2018/8/31.
 */
@Service
public class VariableServiceImpl implements VariableService {

    @Autowired
    private VariableRepository variableRepository;


    @Override
    public Integer addVariable(List<Variable> list, String formulaId, String proId) {
        for (int i = 0; i < list.size(); i++) {
            Variable variable = list.get(i);
            variable.setId(UuidUtil.create32());
            variable.setFormulaId(formulaId);
            variable.setProId(proId);
            variable.setCreateTime(new Date());
            variable.setPosition(i);
        }
        return variableRepository.addVariable(list);
    }

    @Override
    public Integer deleteVariable(String formulaId) {
        return variableRepository.deleteVariable(formulaId);
    }

    @Override
    public List<Variable> selectVariable(String formulaId) {
        return variableRepository.selectVariable(formulaId);
    }

    @Override
    public List<Variable> selectVariables(String[] ids) {
        return variableRepository.selectVariables(ids);
    }
}
