package org.rcisoft.business.mainte.adaptive.service;

import org.rcisoft.business.mainte.adaptive.vo.BuildingAdaptation;
import org.rcisoft.business.mainte.adaptive.vo.ClimateAdaptation;
import org.rcisoft.business.mainte.adaptive.vo.Params;
import org.rcisoft.core.model.PersistModel;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * Created by JiChao on 2018/4/28.
 */
public interface AdaptiveService {

    /**
     * 气候自适应
     * @param proId
     * @param year
     * @param month
     * @param day
     * @return
     */
    ClimateAdaptation climateAdaptation(String proId, String year, String month, String day);

    /**
     * 建筑负荷自适应
     * @param proId
     * @param year
     * @param month
     * @param day
     * @return
     */
    BuildingAdaptation buildingAdaptation(String proId, String year, String month, String day);

    /**
     * 逐时负荷
     * @param params
     * @return
     */
    List<Object> buildingList(Params params);

    /**
     * 定时任务，查询城市24小时温度
     * @return
     */
    PersistModel temperature();

    /**
     * 根据ip查询气象信息
     * @param request
     * @return
     */
    Map<String, Object> weather(HttpServletRequest request, String city);

}
