package org.rcisoft.business.mainte.distributed.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.mainte.distributed.entity.EnergyDistributed;
import org.rcisoft.business.mainte.distributed.service.MainteDistributedService;
import org.rcisoft.business.mainte.distributed.vo.EnergyDistributedVo;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Calendar;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by JiChao on 2018/4/23.
 */
@Api(tags = "项目管理--能耗分布")
@RestController
@RequestMapping("maintedistributed")
public class MainteDistributedController {

    /*
    GoGlic
     */

    @Autowired
    private MainteDistributedService mainteDistributedServiceImpl;
    //int month;

    @ApiOperation(value="能耗分布", notes="能耗分布")
    @ApiImplicitParams({@ApiImplicitParam(name = "year", value = "年", required = true, dataType = "字符串或数字"),
            @ApiImplicitParam(name = "month", value = "月", required = true, dataType = "字符串或数字")
    })
    @RequestMapping("/queryEnergyDistributed")
    public Result queryEnergyDistributed(@RequestParam String year, @RequestParam(required = false) String month) {
        Calendar cale =Calendar.getInstance();//创建一个日历类
        int  month_now = cale.get(Calendar.MONTH)+1;//得到当前月份
        List<EnergyDistributedVo> list = new ArrayList<>();//
        if(month.equals(String.valueOf(month_now))){
            list=null;
        }else{
            list =mainteDistributedServiceImpl.queryEnergyDistributed(year, month);
        }
        return Result.builder(new PersistModel(1), MessageConstant.MESSAGE_ALERT_SUCCESS, MessageConstant.MESSAGE_ALERT_ERROR,list);
    }

    @ApiOperation(value="能耗对比", notes="能耗对比")
    @ApiImplicitParams({@ApiImplicitParam(name = "year", value = "年", required = true, dataType = "字符串或数字"),
            @ApiImplicitParam(name = "bldZoneId", value = "分区id", required = true, dataType = "字符串或数字")
    })
    @RequestMapping("/queryEnergyCompared")
    public Result queryEnergyCompared(@RequestParam String year, @RequestParam String bldZoneId) {





        return Result.builder(new PersistModel(1), MessageConstant.MESSAGE_ALERT_SUCCESS, MessageConstant.MESSAGE_ALERT_ERROR, mainteDistributedServiceImpl.queryEnergyCompared(year, bldZoneId));
    }

    @ApiOperation(value="建筑年代统计", notes="建筑年代统计")
    @ApiImplicitParams({})
    @RequestMapping("/queryBuildingAge")
    public Result queryBuildingAge() {
        return Result.builder(new PersistModel(1), MessageConstant.MESSAGE_ALERT_SUCCESS, MessageConstant.MESSAGE_ALERT_ERROR, mainteDistributedServiceImpl.queryBuildingAge());
    }

    @ApiOperation(value="设备年代统计", notes="设备年代统计")
    @ApiImplicitParams({})
    @RequestMapping("/queryDeviceAge")
    public Result queryDeviceAge() {
        return Result.builder(new PersistModel(1), MessageConstant.MESSAGE_ALERT_SUCCESS, MessageConstant.MESSAGE_ALERT_ERROR, mainteDistributedServiceImpl.queryDeviceAge());
    }

}
