package org.rcisoft.business.mainte.energyplan.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.mainte.energyplan.entity.BusEnergyplanT;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with  on 2018-6-1 9:57:38.
*/
@Repository
public interface BusEnergyplanTRepository extends BaseMapper<BusEnergyplanT> {

    /**
    *查询单个设备某一天的能耗计划概览
    */
    @Select("<script>select * from bus_energyplan_t where dev_num = #{devNum} " +
            " and day = #{day} </script>")
    List<Map<String,Object>> queryBusEnergyplanTs(@Param("devNum") String devNum,@Param("day") String day);

    /**
     * 删除项目某一天的能耗计划概览
     * @param day
     * @param proId
     */
    @Select("<script>delete from bus_energyplan_t where day = #{day} and dev_num in (select dev_num from bus_device where pro_id = #{proId})</script>")
    void deleteEnergyPlanT(@Param("day") String day,@Param("proId") String proId);


    /**
     *查询单个项目某一天的能耗计划概览
     * @return
     */
    @Select("<script>select * from bus_energyplan_t a,bus_device b where a.DEV_NUM = b.DEV_NUM and " +
            " b.PRO_ID = #{proId} and a.`DAY` = #{day} " +
            "</script>")
    List<Map<String,Object>> queryBusEnergyPlanTs(@Param("proId") String proId, @Param("day") String day);
}

