package org.rcisoft.business.mainte.energyplan.service.impl;

import lombok.extern.slf4j.Slf4j;
import org.rcisoft.business.mainte.energyplan.dao.BusEnergyplanTRepository;
import org.rcisoft.business.mainte.energyplan.entity.BusEnergyplanT;
import org.rcisoft.business.mainte.energyplan.service.BusEnergyplanTService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import tk.mybatis.mapper.entity.Example;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

/**
 * Created by  on 2018-6-1 9:57:38.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class BusEnergyplanTServiceImpl implements BusEnergyplanTService {

    @Autowired
    private BusEnergyplanTRepository busEnergyplanTRepository;


    @Transactional
    @Override
    public Boolean save(List<BusEnergyplanT> busEnergyplanTList) {
        try{
            for(BusEnergyplanT busEnergyplanT : busEnergyplanTList){
                busEnergyplanT.setId(UUID.randomUUID().toString().replace("-",""));
                busEnergyplanTRepository.insertSelective(busEnergyplanT);
            }
        }catch(Exception e){
            return false;
        }
        return true;
    }

    @Override
    public Boolean remove(String devNum,String day) {
        if(devNum==null || devNum.equals("")) return false;
        if(day==null || day.equals("")) return false;
        Boolean flag = false;
        Example example = new Example(BusEnergyplanT.class);
        Example.Criteria criteria = example.createCriteria();
        Map<String,Object> map = new HashMap<>();
        BusEnergyplanT bt = new BusEnergyplanT();
        bt.setDevNum(devNum);
        bt.setDay(day);
        criteria.andEqualTo(bt);
        int line =busEnergyplanTRepository.delete(bt);
        if(line>=0){flag = true;}
        return flag;
    }

    @Override
    public List<Map<String, Object>> queryBusEnergyplanTs(String devNum, String day) {
        return busEnergyplanTRepository.queryBusEnergyplanTs(devNum,day);
    }
}
