package org.rcisoft.business.mainte.paramlibrary.service.impl;

import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellType;
import org.apache.poi.ss.util.CellRangeAddress;
import org.rcisoft.business.mainte.energyplan.dao.BusEnergyPlanRepository;
import org.rcisoft.business.mainte.energyplan.dao.BusEnergyplanTRepository;
import org.rcisoft.business.mainte.energyplan.entity.BusEnergyPlan;
import org.rcisoft.business.mainte.energyplan.entity.BusEnergyplanT;
import org.rcisoft.business.mainte.paramlibrary.dao.ParamLibraryRepository;
import org.rcisoft.business.mainte.paramlibrary.entity.BusParamLibrary;
import org.rcisoft.business.mainte.paramlibrary.service.ParamLibraryService;
import org.rcisoft.business.mainte.paramlibrary.vo.BusParamLibraryList;
import org.rcisoft.business.manage.dao.BusLibraryParamRepository;
import org.rcisoft.business.overview.dao.BusEnergyplanVRepository;
import org.rcisoft.business.overview.entity.BusEnergyplanV;
import org.rcisoft.core.model.PersistModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;
import tk.mybatis.mapper.entity.Example;

import javax.servlet.http.HttpServletResponse;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.*;

@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class ParamLibraryServiceImpl implements ParamLibraryService {
    @Autowired
    private ParamLibraryRepository paramLibraryRepository;
    @Autowired
    private BusLibraryParamRepository busLibraryParamRepository;
    @Autowired
    private BusEnergyPlanRepository busEnergyPlanRepository;
    @Autowired
    private BusEnergyplanTRepository busEnergyplanTRepository;
    @Autowired
    private BusEnergyplanVRepository busEnergyplanVRepository;

    @Override
    public Map<String, Object> queryLibraryParamByDev(Map<String, Object> map) {
        Map<String, Object> result = new HashMap<String, Object>();
        List<Map<String, Object>> mainParam = new ArrayList<>();
        List<Map<String, Object>> otherParam = new ArrayList<>();
        List<Map<String, Object>> list = paramLibraryRepository.queryLibraryParamByDev(map);
        list.forEach(map1 -> {
            String flag = (String) map1.get("compare_flag");
            if (flag.equals("1"))
                mainParam.add(map1);
            else
                otherParam.add(map1);
        });
        result.put("mainParam", mainParam);
        result.put("otherParam", otherParam);
        return result;
        // 如果list=4，将主参数合并
//        if (list.size() == 4) {
//            List<Map<String, Object>> list_4 = new ArrayList<>();
//            // 合并前两个
//            Map<String, Object> map1and2 = new HashMap<>();
//            map1and2.put("compare_flag", "1");
//            map1and2.put("param", list.get(0).get("param") + "/" + list.get(1).get("param"));
//            map1and2.put("param_nm", list.get(0).get("param_nm") + "/" + list.get(1).get("param_nm"));
//            map1and2.put("param_unit", list.get(0).get("param_unit") + "/" + list.get(1).get("param_unit"));
//            map1and2.put("p_source", list.get(0).get("p_source") + "/" + list.get(1).get("p_source"));
//            // 放入返回值
//            list_4.add(map1and2);
//            list_4.add(list.get(2));
//            list_4.add(list.get(3));
//            return list_4;
//        } else {
//            return list;
//        }
//        return list;
    }

    @Override
    public List<Map<String, Object>> queryPlanParamVal_1(Map<String, Object> map) {
        SimpleDateFormat simple = new SimpleDateFormat("yyyy");
        map.put("year",simple.format(new Date()));
//        List<Map<String, Object>> list = paramLibraryRepository.queryPlanParamVal_1(map);
//        list.forEach(map1 -> {
//            Object p1_v = map1.get("p1_v");
//            Object p2_v = map1.get("p2_v");
//            if (p2_v != null) {
//                map1.put("p1_v", p1_v + "/" + p2_v);
//            }
//            map1.remove("p2_v");
//        });
        return paramLibraryRepository.queryPlanParamVal_1(map);
    }

    @Override
    public List<Map<String, Object>> queryPlanParamVal_2(Map<String, Object> map) {
        SimpleDateFormat simple = new SimpleDateFormat("yyyy");
        map.put("year",simple.format(new Date()));
//        // 如果 p1_v 是两个参数组成的
//        String p1_v = (String) map.get("p1_v");
//        String[] split = p1_v.split("/");
//        if (split.length == 2) {
//            map.put("p1_v", split[0]);
//            map.put("p2_v", split[1]);
//        }
        return paramLibraryRepository.queryPlanParamVal_2(map);
    }

    @Override
    public List<Map<String, Object>> queryPlanParamVal_3(Map<String, Object> map) {
        SimpleDateFormat simple = new SimpleDateFormat("yyyy");
        map.put("year",simple.format(new Date()));
        return paramLibraryRepository.queryPlanParamVal_3(map);
    }

    @Override
    public List<Map<String, Object>> queryParamLibrary(Map<String, Object> map) {
        return paramLibraryRepository.queryParamLibrary(map);
    }

    @Override
    public PersistModel save(BusParamLibraryList busPramLibraryList) {
        for(BusParamLibrary bp : busPramLibraryList.getBusParamLibraryList()){
            Map<String,Object> map = new HashMap<>();
            map.put("dev_num",bp.getDevNum());
            map.put("p1_v",bp.getP1V());
            map.put("p2_v",bp.getP2V());
            map.put("p3_v",bp.getP3V());
            map.put("year",bp.getYear());
            if(paramLibraryRepository.queryParamLibrary(map)==null || paramLibraryRepository.queryParamLibrary(map).size()<1) {
                paramLibraryRepository.insertSelective(bp);
            }
        }
        return new PersistModel(1);
    }

    @Override
    public PersistModel delete(String devNum) {
        Example example = new Example(BusParamLibrary.class);
        Example.Criteria criteria = example.createCriteria();
        criteria.andEqualTo("devNum",devNum);
        int line = paramLibraryRepository.deleteByExample(example);
        return new PersistModel(line);
    }

    @Override
    public void downloadExcel(HttpServletResponse response, String devNum) {
        try(OutputStream outputStream = response.getOutputStream()) {
            //设置下载头
            response.setHeader("Content-disposition", "attachment;filename=" + devNum + ".xls");
            outputStream.write(this.createExcel(devNum));
            outputStream.flush();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @Transactional
    @Override
    public PersistModel uploadExcel(MultipartFile file, String devNum) {
        // 返回值
        Integer resultCount = 0;
        String resultMsg = "";
        HSSFWorkbook workbook = null;
        List<BusParamLibrary> resultList = new ArrayList<>();
//        int result = 0;
        try(InputStream is = file.getInputStream()) {
            workbook = new HSSFWorkbook(is);
            //读取sheet
            HSSFSheet sheet = workbook.getSheetAt(0);
            //从第一行开始读取
            HSSFRow first_row = sheet.getRow(0);
            //第一行得到devNum，年份
            String excel_devNum = "";
            String year = "";
            if (first_row != null) {
                excel_devNum = this.getValue(first_row.getCell(1));
                year = this.getValue(first_row.getCell(4));
                //如果不等于页面传来的值，直接返回
                if (!StringUtils.equals(excel_devNum, devNum)) {
                    resultMsg = "设备编号不一致";
                    return new PersistModel(resultCount, resultMsg);
                }
            }
            //取得4个参数
            String param1 = this.getCode(sheet, 3, 2),
                    param2 = this.getCode(sheet, 4, 2),
                    param3 = this.getCode(sheet, 5, 2),
                    param4 = this.getCode(sheet, 6, 2);
            // 取得参数代码code
            String code1 = this.getCode(sheet, 3, 3),
                    code2 = this.getCode(sheet, 4, 3),
                    code3 = this.getCode(sheet, 5, 3),
                    code4 = this.getCode(sheet, 6, 3);
            // 取得参数来源
            String p1S = this.getCode(sheet, 3, 4),
                    p2S = this.getCode(sheet, 4, 4);
            // 如果不是4个参数，需要改变顺序
            int empty = 0;
            if (StringUtils.isEmpty(param1)) empty++;
            if (StringUtils.isEmpty(param2)) empty++;
            if (StringUtils.isEmpty(param3)) empty++;
            if (StringUtils.isEmpty(param4)) empty++;
            if (empty > 0) {
                param4 = param3;
                param3 = param2;
                param2 = null;
                code4 = code3;
                code3 = code2;
                code2 = null;
                p2S = null;
            }
            
            if (StringUtils.isNotEmpty(p1S)) {
                if (StringUtils.equals(p1S, "设备")) p1S = "1";
                else p1S = "2";
            }
            if (StringUtils.isNotEmpty(p2S)) {
                if (StringUtils.equals(p2S, "设备")) p2S = "1";
                else p2S = "2";
            }
            //如果code1、2、3、4都没有值，表示没有添加参数模板
            if (StringUtils.isEmpty(param1) && StringUtils.isEmpty(param2) && StringUtils.isEmpty(param3) && StringUtils.isEmpty(param4)) {
                
            } else {
                //读取需要保存的数据
                for (int i = 9; i < sheet.getLastRowNum() + 1; i++) {
                    BusParamLibrary b = new BusParamLibrary();
                    HSSFRow row = sheet.getRow(i);
                    if (row != null) {
                        String power = this.getValue(row.getCell(1));//功率
                        String speed = this.getValue(row.getCell(2));//用气速率
                        String param1Value = this.getValue(row.getCell(3));//参数1
                        String param2Value = this.getValue(row.getCell(4));//参数2
                        String param3Value = this.getValue(row.getCell(5));//参数3
                        String param4Value = this.getValue(row.getCell(6));//参数4
                        //如果都为null，表明已经没有数据，跳出循环
                        if (StringUtils.isEmpty(power) && StringUtils.isEmpty(speed) && StringUtils.isEmpty(param1Value) && StringUtils.isEmpty(param2Value) && StringUtils.isEmpty(param3Value) && StringUtils.isEmpty(param4Value)) break;
                        // 判断输入的内容，错误的输入方式不保存直接退出
                        // 功率不能为空
                        if (power == null) {
                            resultMsg = "功率不能为空";
                            return new PersistModel(resultCount, resultMsg);
                        }
                        // 主参数1不能为空
                        if (param1Value == null) {
                            resultMsg = "参数1的值不能为空";
                            return new PersistModel(resultCount, resultMsg);
                        }
                        // 当存在4个参数的时候，四个参数均不能为空
                        if (param2 != null) {
                            if (param2Value == null || param3Value == null || param4Value == null) {
                                resultMsg = "参数为4个时，参数值均不能为空";
                                return new PersistModel(resultCount, resultMsg);
                            }
                        } else {
                            // 当存在3个以下参数的时候
                            // 当存在3个参数时，参数3,4不能为空
                            if (param3 != null && param4 != null) {
                                if (param3Value == null || param4Value == null) {
                                    resultMsg = "参数为3个时，参数3、4的值不能为空";
                                    return new PersistModel(resultCount, resultMsg);
                                }
                            }
                            // 当存在2个参数时，参数3不能为空
                            if (param3 != null) {
                                if (param3Value == null) {
                                    resultMsg = "参数为2个时，参数3的值不能为空";
                                    return new PersistModel(resultCount, resultMsg);
                                }
                            }
                        }
                        //赋值
                        b.setDevNum(devNum);
                        b.setPower(StringUtils.isEmpty(power) ? null : new BigDecimal(power));
                        b.setGasSpeed(StringUtils.isEmpty(speed) ? null : new BigDecimal(speed));
                        b.setYear(year);
                        b.setP1(param1);
                        b.setP1V(StringUtils.isEmpty(param1Value) ? null : new BigDecimal(param1Value));
                        b.setP2(param2);
                        b.setP2V(StringUtils.isEmpty(param2Value) ? null : new BigDecimal(param2Value));
                        b.setP3(param3);
                        b.setP3V(StringUtils.isEmpty(param3Value) ? null : new BigDecimal(param3Value));
                        b.setP4(param4);
                        b.setP4V(StringUtils.isEmpty(param4Value) ? null : new BigDecimal(param4Value));
                        b.setP1S(p1S);
                        b.setP2S(p2S);
                        b.setP1C(code1);
                        b.setP2C(code2);
                        b.setP3C(code3);
                        b.setP4C(code4);
                        resultList.add(b);
                    }
                }
                //先删除数据库的数据，再保存
                if (resultList.size() > 0) {
                    BusParamLibrary b = new BusParamLibrary();
                    b.setDevNum(devNum);
                    b.setYear(year);
                    //先删除
                    paramLibraryRepository.delete(b);
                    //清空今天及今天之后的数据bus_energy_plan，bus_energyplan_t，bus_energyplan_v
                    String date = new SimpleDateFormat("yyyy-MM-dd 00:00:00").format(new Date());
                    // 3.根据dev_num删除bus_energy_plan
                    Example example_BusEnergyPlan = new Example(BusEnergyPlan.class);
                    Example.Criteria criteria_BusEnergyPlan = example_BusEnergyPlan.createCriteria();
                    criteria_BusEnergyPlan.andEqualTo("devNum", devNum);
                    criteria_BusEnergyPlan.andGreaterThanOrEqualTo("tm", date);
                    busEnergyPlanRepository.deleteByExample(example_BusEnergyPlan);
                    // 4.根据dev_num删除bus_energyplan_t
                    Example example_BusEnergyplanT = new Example(BusEnergyplanT.class);
                    Example.Criteria criteria_BusEnergyplanT = example_BusEnergyplanT.createCriteria();
                    criteria_BusEnergyplanT.andEqualTo("devNum", devNum);
                    criteria_BusEnergyplanT.andGreaterThanOrEqualTo("startTm", date);
                    busEnergyplanTRepository.deleteByExample(example_BusEnergyplanT);
                    // 5.根据dev_num删除bus_energyplan_v
                    Example example_BusEnergyplanV = new Example(BusEnergyplanV.class);
                    Example.Criteria criteria_BusEnergyplanV = example_BusEnergyplanV.createCriteria();
                    criteria_BusEnergyplanV.andEqualTo("devNum", devNum);
                    criteria_BusEnergyplanV.andGreaterThanOrEqualTo("tm", date);
                    busEnergyplanVRepository.deleteByExample(example_BusEnergyplanV);
                    //添加
                    resultCount = paramLibraryRepository.saveBusParamLibraryList(resultList);
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                workbook.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return new PersistModel(resultCount, resultMsg);
    }

    /**
     * 创建下载的excel流
     * @param devNum
     * @return
     */
    private byte[] createExcel(String devNum) throws IOException {
        //定义行号
        int rowNum = 0;
        HSSFWorkbook workbook = new HSSFWorkbook();
        HSSFSheet sheet = workbook.createSheet("sheet1");
        //第一行：设备编号 + 年份
        HSSFRow row_1 = sheet.createRow(rowNum++);
        row_1.createCell(0, CellType.STRING).setCellValue("设备编号");
        row_1.createCell(1, CellType.STRING).setCellValue(devNum);
        row_1.createCell(3, CellType.STRING).setCellValue("年份");
        row_1.createCell(4, CellType.STRING).setCellValue(Calendar.getInstance().get(Calendar.YEAR));
        //空一行
        rowNum++;
        // 第三行：参数、参数名称、参数编码
        String[] title_3 = new String[]{"参数", "名称", "编码", "编码code", "来源", "类型"};
        HSSFRow row_3 = sheet.createRow(rowNum++);
        for (int i = 0; i < title_3.length; i++) {
            row_3.createCell(i, CellType.STRING).setCellValue(title_3[i]);
        }
        //循环参数列表
        List<Map<String, String>> paramsList = busLibraryParamRepository.selectParamsByDevNum(devNum);
        int size = paramsList.size();
        for (int i = 0; i < size; i++) {
            Map<String, String> param = paramsList.get(i);
            HSSFRow row = sheet.createRow(rowNum++);
            row.createCell(0, CellType.STRING).setCellValue(i + 1);//编号
            row.createCell(1, CellType.STRING).setCellValue(param.get("paramNm"));//参数名称
            row.createCell(2, CellType.STRING).setCellValue(param.get("param"));//参数编码
            row.createCell(3, CellType.STRING).setCellValue(param.get("paramCode"));//编码code
            row.createCell(4, CellType.STRING).setCellValue(param.get("source").equals("1") ? "设备" : "传感器");//来源
            // 给主参数加上注释
            if (StringUtils.equals(param.get("compareFlag"), "1"))
                row.createCell(5, CellType.STRING).setCellValue("主参数");
        }
        // 表明参数类型行
        rowNum = rowNum + 4 - size;
        // 合并单元格
        CellRangeAddress cra1 = new CellRangeAddress(7, 7, 3, 4);
        CellRangeAddress cra2 = new CellRangeAddress(7, 7, 5, 6);
        //在sheet里增加合并单元格
        sheet.addMergedRegion(cra1);
        sheet.addMergedRegion(cra2);
        HSSFRow row_param_title = sheet.createRow(rowNum);
        row_param_title.createCell(3, CellType.STRING).setCellValue("主参数");
        row_param_title.createCell(5, CellType.STRING).setCellValue("其他参数");
        rowNum++;
        //添加参数值表头列
        HSSFRow row_next = sheet.createRow(rowNum);
        row_next.createCell(0, CellType.STRING).setCellValue("参数值列表");
        row_next.createCell(1, CellType.STRING).setCellValue("功率（kw）");
        row_next.createCell(2, CellType.STRING).setCellValue("用气速率（m3/h）");
        for (int i = 0; i < 4; i++) {
            row_next.createCell(3 + i, CellType.STRING).setCellValue("参数" + (i + 1) + "值");
        }
        try(ByteArrayOutputStream os = new ByteArrayOutputStream()) {
            workbook.write(os);
            return os.toByteArray();
        } finally {
            workbook.close();
        }
    }

    /**
     * 读取cell的内容
     * @param cell
     * @return
     */
    @SuppressWarnings("deprecation")
    private String getValue(HSSFCell cell) {
        if (cell == null) return null;
        switch (cell.getCellType()) {
            case Cell.CELL_TYPE_BOOLEAN:
                return cell.getBooleanCellValue() ? "TRUE" : "FALSE";
            case Cell.CELL_TYPE_FORMULA:
                return cell.getCellFormula();
            case Cell.CELL_TYPE_NUMERIC:
                cell.setCellType(Cell.CELL_TYPE_STRING);
                return cell.getStringCellValue();
            case Cell.CELL_TYPE_STRING:
                return cell.getStringCellValue();
            default:
                return null;
        }
    }

    /**
     * 读取code
     * @param sheet
     * @param row
     * @return
     */
    private String getCode(HSSFSheet sheet, int row, int col) {
        HSSFRow sheetRow = sheet.getRow(row);
        if (sheetRow == null) return null;
        else return this.getValue(sheetRow.getCell(col));
    }
}
