package org.rcisoft.business.manage.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.manage.entity.BusFixedParam;
import org.rcisoft.business.manage.service.BusFixedParamService;
import org.rcisoft.business.manage.vo.BusFixedParamVo;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * Created by JiChao on 2018/9/26.
 */
@Api(tags = "固定参数")
@RestController
@RequestMapping("fixed")
public class BusFixedParamController {

    @Autowired
    private BusFixedParamService busFixedParamServiceImpl;

    @ApiOperation(value="添加", notes="添加")
    @PostMapping(value = "/save")
    public Result save(@RequestBody BusFixedParamVo busFixedParamVo) {
        Integer result = busFixedParamServiceImpl.save(busFixedParamVo);
        return Result.builder(new PersistModel(result),
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                result);
    }

    @ApiOperation(value="修改", notes="修改")
    @PostMapping(value = "/update")
    public Result update(@RequestBody BusFixedParamVo busFixedParamVo) {
        Integer result = busFixedParamServiceImpl.update(busFixedParamVo);
        return Result.builder(new PersistModel(result),
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                result);
    }

    @ApiOperation(value="删除", notes="删除")
    @PostMapping(value = "/delete")
    public Result delete(@RequestParam String devTpId, @RequestParam String proId) {
        Integer result = busFixedParamServiceImpl.delete(devTpId, proId);
        return Result.builder(new PersistModel(result),
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                result);
    }

    @ApiOperation(value="查询", notes="查询")
    @PostMapping(value = "/selectBusFixedParamList")
    public Result selectBusFixedParamList(@RequestParam String proId) {
        return Result.builder(new PersistModel(1),
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                busFixedParamServiceImpl.selectBusFixedParamList(proId));
    }
}
