package org.rcisoft.business.manage.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.manage.service.EnergyEmissionPlanService;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created by JiChao on 2018/5/31.
 * 基准（计划）碳排放量
 */
@Api(tags = "基准碳排放量")
@RestController
@RequestMapping("energyplan")
public class EnergyEmissionPlanController {

    @Autowired
    private EnergyEmissionPlanService energyEmissionPlanServiceImpl;

    @ApiOperation(value="下载模板文件", notes="excel文件下载")
    @RequestMapping("/downloadExcel")
    public void downloadExcel(HttpServletRequest request, HttpServletResponse response) {
        energyEmissionPlanServiceImpl.downloadExcel(request, response);
    }

    @ApiOperation(value="上传模板文件", notes="excel文件上传")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "proId", value = "项目主键", required = true, dataType = "字符串")
    })
    @RequestMapping("/uploadExcel")
    public Result uploadExcel(@RequestParam MultipartFile file, @RequestParam String proId) {
        Integer result = energyEmissionPlanServiceImpl.uploadExcel(file, proId);
        return new Result().builder(new PersistModel(result), MessageConstant.MESSAGE_ALERT_SUCCESS, MessageConstant.MESSAGE_ALERT_ERROR, result);
    }

    @ApiOperation(value="判断是否上传过", notes="判断是否上传过")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "proId", value = "项目主键", required = true, dataType = "字符串")
    })
    @RequestMapping("/checkExcel")
    public Result checkExcel(@RequestParam String proId) {
        return new Result().builder(new PersistModel(1), MessageConstant.MESSAGE_ALERT_SUCCESS, MessageConstant.MESSAGE_ALERT_ERROR, energyEmissionPlanServiceImpl.checkExcel(proId));
    }

}
