package org.rcisoft.business.manage.controller;


/*固定导入*/
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.manage.entity.TopologyNode;
import org.rcisoft.business.manage.service.TopologyNodeService;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.controller.PaginationController;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

/**
* Created by  on 2018-6-5 9:01:15.
*/
@RestController
@RequestMapping("manage/topologiesnode")
public class TopologyNodeController extends PaginationController<TopologyNode> {

    @Autowired
    private TopologyNodeService topologyNodeServiceImpl;


    @ApiOperation(value="添加", notes="添加")
    @PostMapping(value = "/add")
    public Result add(@RequestParam MultipartFile file, @RequestParam String proId) {
        return Result.builder(topologyNodeServiceImpl.save(file, proId),
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        null);
    }

    @ApiOperation(value="删除", notes="删除")
    @DeleteMapping("/delete")
    public Result delete(@RequestParam String id) {
        return Result.builder(topologyNodeServiceImpl.remove(id));
    }

    @ApiOperation(value="拓扑图节点图片列表", notes="拓扑图节点图片列表")
    @GetMapping("/query")
    public Result query(@RequestParam String proId) {
        return Result.builder(new PersistModel(1),
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                topologyNodeServiceImpl.queryTopologyNodes(proId));
    }
}
