package org.rcisoft.business.manage.service.impl;

import org.rcisoft.business.device.maintenance.entity.BusDeviceInspect;
import org.rcisoft.business.manage.dao.BusDeviceInspectRepository;
import org.rcisoft.business.manage.service.BusDeviceInspectService;
import org.rcisoft.core.model.PersistModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import tk.mybatis.mapper.entity.Example;

import java.util.Date;
import java.util.UUID;

@Service
public class BusDeviceInspectServiceImpl implements BusDeviceInspectService {
    @Autowired
    private BusDeviceInspectRepository busDeviceInspectRepository;

    @Transactional
    @Override
    public PersistModel save(BusDeviceInspect busDeviceInspect) {
        busDeviceInspect.setInsId(UUID.randomUUID().toString().replace("-",""));
        busDeviceInspect.setInspTm(new Date());
        busDeviceInspect.setFlag("1");
        updateFlag(busDeviceInspect.getDevNum());
        int line = busDeviceInspectRepository.insertSelective(busDeviceInspect);
        return new PersistModel(line);
    }

    @Override
    public int updateFlag(String devNum) {
        BusDeviceInspect bi = new BusDeviceInspect();
        bi.setDevNum(devNum);
        bi.setFlag("0");
        Example ex = new Example(BusDeviceInspect.class);
        Example.Criteria criteria = ex.createCriteria();
        criteria.andEqualTo("devNum",devNum);
        return busDeviceInspectRepository.updateByExampleSelective(bi,ex);
    }
}
