package org.rcisoft.business.manage.service.impl;

import org.rcisoft.business.manage.dao.BusDeviceTpRepository;
import org.rcisoft.business.manage.dao.BusFixedParamRepository;
import org.rcisoft.business.manage.entity.BusDevicetpParam;
import org.rcisoft.business.manage.entity.BusFixedParam;
import org.rcisoft.business.manage.service.BusFixedParamService;
import org.rcisoft.business.manage.vo.BusFixedParamVo;
import org.rcisoft.core.util.IdGen;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import tk.mybatis.mapper.entity.Example;

import java.util.List;
import java.util.Map;

/**
 * Created by JiChao on 2018/9/25.
 */
@Service
public class BusFixedParamServiceImpl implements BusFixedParamService {

    @Autowired
    private BusFixedParamRepository busFixedParamRepository;
    @Autowired
    private BusDeviceTpRepository busDeviceTpRepository;

    @Transactional
    @Override
    public Integer save(BusFixedParamVo busFixedParamVo) {
        List<BusFixedParam> list = busFixedParamVo.getList();
        String devTpId = busFixedParamVo.getDevTpId();
        String proId = busFixedParamVo.getProId();
        list.forEach(busFixedParam -> {
            busFixedParam.setId(IdGen.uuid());
            busFixedParam.setDevTpId(devTpId);
            busFixedParam.setProId(proId);
        });
        return busFixedParamRepository.save(list);
    }

    @Transactional
    @Override
    public Integer update(BusFixedParamVo busFixedParamVo) {
        String devTpId = busFixedParamVo.getDevTpId();
        String proId = busFixedParamVo.getProId();
        Integer delete = this.delete(devTpId, proId);
        Integer save = this.save(busFixedParamVo);
        return save;
    }

    @Transactional
    @Override
    public Integer delete(String devTpId, String proId) {
        Example example = new Example(BusFixedParam.class);
        Example.Criteria criteria = example.createCriteria();
        criteria.andEqualTo("devTpId", devTpId)
                .andEqualTo("proId", proId);
        return busFixedParamRepository.deleteByExample(example);
    }

    @Override
    public List<Map<String, Object>> selectBusFixedParamList(String proId) {
        List<Map<String,Object>> list = busDeviceTpRepository.queryBusDeviceTps(proId);
        for(Map<String,Object> tmap : list){
            Example example = new Example(BusFixedParam.class);
            Example.Criteria criteria = example.createCriteria();
            criteria.andEqualTo("devTpId", tmap.get("DEV_TP_ID"))
                    .andEqualTo("proId", proId);
            tmap.put("paramList", busFixedParamRepository.selectByExample(example));
        }
        return list;
    }

    @Override
    public List<BusFixedParam> queryBusFixedParamList(String devNum, String proId) {
        return busFixedParamRepository.queryBusFixedParamList(devNum, proId);
    }
}
