package org.rcisoft.business.overview.dao;

import org.apache.ibatis.annotations.Param;
import org.rcisoft.business.overview.entity.BusEnergyplanV;
import org.rcisoft.business.overview.vo.BusEnergyPlanVo;
import org.rcisoft.core.base.BaseMapper;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with  on 2018-4-19 9:20:45.
*/
@Repository
public interface BusEnergyplanVRepository extends BaseMapper<BusEnergyplanV> {

    /**
     * 查询每年的用能计划
     * @param proId
     * @return
     */
    @Select("<script>SELECT date_format(b.TM, '%Y') `YEAR`,sum(b.ENERGY_MONEY) ENERGY_MONEY " +
            "FROM bus_energyplan_v b, bus_device d " +
            "WHERE b.DEV_NUM = d.DEV_NUM AND d.PRO_ID = #{proId} " +
            "group by date_format(b.TM,'%Y') " +
            "order by date_format(b.TM,'%Y')+0 asc</script>")
    @ResultMap(value = "vo")
    List<BusEnergyPlanVo> statEnergyPlan(@Param("proId") String proId);

    @Select("<script>select date_format(b.TM,'%c') MON,sum(if(b.ENERGY_MONEY is null,0,b.ENERGY_MONEY)) ENERGY_MONEY from bus_energyplan_v b,bus_device d where b.DEV_NUM=d.DEV_NUM and d.PRO_ID=#{proId} and date_format(b.TM,'%Y')=#{time} group by date_format(b.TM,'%c') order by date_format(b.TM,'%c')+0 asc</script>")
    @ResultMap(value = "vo")
    List<BusEnergyPlanVo> statEnergyPlanYear(BusEnergyPlanVo busEnergyPlanVo);

    @Select("<script>select date_format(b.TM,'%e') `DAY`,sum(if(b.ENERGY_MONEY is null,0,b.ENERGY_MONEY)) ENERGY_MONEY from bus_energyplan_v b,bus_device d where b.DEV_NUM=d.DEV_NUM and d.PRO_ID=#{proId} and date_format(b.TM,'%Y-%c')=#{time} group by date_format(b.TM,'%e') order by date_format(b.TM,'%e')+0 asc</script>")
    @ResultMap(value = "vo")
    List<BusEnergyPlanVo> statEnergyPlanMonth(BusEnergyPlanVo busEnergyPlanVo);

    @Select("<script>select date_format(b.TM,'%k') `HOUR`,sum(if(b.ENERGY_MONEY is null,0,b.ENERGY_MONEY)) ENERGY_MONEY from bus_energyplan_v b,bus_device d where b.DEV_NUM=d.DEV_NUM and d.PRO_ID=#{proId} and date_format(b.TM,'%Y-%c-%e')=#{time} group by date_format(b.TM,'%k') order by date_format(b.TM,'%k')+0 asc</script>")
    @ResultMap(value = "vo")
    List<BusEnergyPlanVo> statEnergyPlanDay(BusEnergyPlanVo busEnergyPlanVo);
}

