package org.rcisoft.business.system.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.ResultType;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.system.entity.DeviceParam;
import org.rcisoft.business.system.vo.ParamStatus;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * Created by JiChao on 2018/5/24.
 */
@Repository
public interface DeviceParamRepository {

    /**
     * 查询参数列表
     * @param devNum
     * @return
     */
    @Select("<script>select p.PARAM,t.PARAM_NM,t.P_SOURCE,t.P_MIN,t.P_MAX,t.SYMBOL,t.FLAG,t.PARAM_UNIT,t.PARAM_CODE " +
            "from bus_device d left join bus_devicetp_param t on d.DEV_TP_ID=t.DEV_TP_ID " +
            "left join bus_device_param p on t.PARAM_CODE=p.PARAM_CODE and p.DEV_NUM=#{devNum} " +
            "where d.DEV_NUM=#{devNum} and d.PRO_ID=#{proId} order by t.PARAM_NM</script>")
    @ResultMap("BaseResultMap")
    List<DeviceParam> selectDeviceParamList(@Param("devNum") String devNum, @Param("proId") String proId);

    @Select("<script>select OTHER_PARAM from bus_param_refer where PRO_ID=#{proId} and OWN_PARAM='sensor'</script>")
    @ResultType(String.class)
    String selectSensorCode(@Param("proId") String proId);

    @Select("<script>select MET_NUM power from bus_device_meter where PRO_ID=#{proId} and DEV_NUM=#{devNum}</script>")
    @ResultType(String.class)
    String selectMetNum(@Param("proId") String proId, @Param("devNum") String devNum);

    @Select("<script>SELECT d.DEV_NM devNm,r.DEV_NUM devNum,r.OTHER_PARAM param,d.PRO_ID proId " +
            "FROM bus_device d " +
            "left join bus_device_meter m on m.DEV_NUM = d.DEV_NUM " +
            "left join bus_param_refer r on m.MET_NUM = r.DEV_NUM " +
            "WHERE d.PRO_ID = #{proId} order by d.DEV_NUM desc</script>")
    @ResultType(ParamStatus.class)
    List<ParamStatus> selectDeviceAll(@Param("proId") String proId);

    @Select("<script>select r.DEV_NUM devCode,r.OTHER_PARAM devParam,r.PRO_ID proId from bus_device_meter m,bus_param_refer r where m.MET_NUM=r.DEV_NUM and m.DEV_NUM=#{devNum}</script>")
    @ResultType(Map.class)
    Map<String, String> selectPower(@Param("devNum") String devNum);

}
