package org.rcisoft.business.system.service;

import org.rcisoft.business.device.assets.entity.BusDevice;
import org.rcisoft.business.system.entity.DeviceParam;
import org.rcisoft.business.system.vo.ClimateStatistics;
import org.rcisoft.business.system.vo.ParamStatus;
import org.rcisoft.business.system.vo.ParamStatusList;

import java.util.List;
import java.util.Map;

/**
 * Created by JiChao on 2018/5/2.
 */
public interface SystemService {

    /**
     * 气候自适应统计
     * @param proId
     * @return
     */
    ClimateStatistics statClimate(String proId);

    /**
     * 能源消耗
     * @param proId
     * @return
     */
    List<Object> energyConsume(String proId);

    /**
     * 逐时负荷
     * @param proId
     * @return
     */
    List<Object> burdenHour(String proId);

    /**
     * 查询该项目下所有设备的故障数量和运行时长
     * @param proId
     * @return
     */
    List<BusDevice> selectErrorandRuntime(String proId);

    /**
     * 根据devNum查询参数列表
     * @param devNum
     * @return
     */
    Map<String, Object> selectDeviceParamList(String devNum);

    /**
     * 查询传感器code
     * @param proId
     * @return
     */
    Map<String, String> selectSensorCode(String proId, String devNum);

    /**
     * 查询缓存中的数据，10秒钟查询1次
     * @param proId
     * @return
     */
    String selectDataByCache(String proId);

    /**
     * 查询项目下所有设备的信息
     * @param proId
     * @return
     */
    List<ParamStatus> selectDeviceAll(String proId);

    /**
     * 查询每个设备的状态
     * @param list
     * @return
     */
    List<ParamStatus> selectDeviceStatus(ParamStatusList list);

}
